'use strict';


if ( typeof window !== 'undefined' ) {
  if ( !window['__REKA__'] ) {
    window['__REKA__'] = {};
  }
  
  window['__REKA__']["@depla/react-code-editor"] = "0.1.4";
}
  

Object.defineProperty(exports, '__esModule', { value: true });

var commands = require('@codemirror/commands');
var state = require('@codemirror/state');
var view = require('@codemirror/view');
var codemirror$1 = require('@rekajs/codemirror');
var parser = require('@rekajs/parser');
var react = require('@rekajs/react');
var t = require('@rekajs/types');
var codemirror = require('codemirror');
var debounce = require('lodash/debounce');
var React = require('react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n["default"] = e;
    return Object.freeze(n);
}

var t__namespace = /*#__PURE__*/_interopNamespace(t);
var debounce__default = /*#__PURE__*/_interopDefaultLegacy(debounce);
var React__namespace = /*#__PURE__*/_interopNamespace(React);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

var _diffASTArrayTypes = function (program, newProgram, getTarget, isEqual) {
    var currentComponents = getTarget(program);
    var newComponents = getTarget(newProgram);
    var componentsToInsert = [];
    newComponents.forEach(function (newComponent, i) {
        var existingComponent = currentComponents.find(function (oldComponent) {
            return isEqual(oldComponent, newComponent);
        });
        if (!existingComponent) {
            componentsToInsert.push([newComponent, i]);
            return;
        }
        t__namespace.merge(existingComponent, newComponent);
    });
    componentsToInsert.forEach(function (_a, i) {
        var _b = __read(_a, 2), component = _b[0], index = _b[1];
        currentComponents.splice(index + i, 0, component);
    });
    currentComponents
        .filter(function (oldComponent) {
        return !newComponents.find(function (newComponent) {
            return isEqual(oldComponent, newComponent);
        });
    })
        .forEach(function (component) {
        currentComponents.splice(currentComponents.indexOf(component), 1);
    });
};
var diffAST = function (program, newProgram) {
    // Diff Globals
    _diffASTArrayTypes(program, newProgram, function (program) { return program.globals; }, function (a, b) { return a.name === b.name; });
    // Diff components
    _diffASTArrayTypes(program, newProgram, function (program) { return program.components; }, function (a, b) { return a.name === b.name; });
};
var CodeEditor = function (_a) {
    var _b;
    var onStatusChange = _a.onStatusChange, props = __rest(_a, ["onStatusChange"]);
    var reka = react.useReka().reka;
    var domRef = React__namespace.useRef(null);
    var onStatusChangeRef = React__namespace.useRef(onStatusChange);
    onStatusChangeRef.current = onStatusChange;
    var currentStateRef = React__namespace.useRef(t__namespace.Schema.fromJSON(reka.program));
    var currentCodeStringRef = React__namespace.useRef(parser.Parser.stringify(reka.program));
    var extensionsRef = React__namespace.useRef((_b = props.extensions) !== null && _b !== void 0 ? _b : []);
    extensionsRef.current = props.extensions || [];
    var isSynchingFromCodeMirror = React__namespace.useRef(false);
    var isSynchingFromExternal = React__namespace.useRef(false);
    var isTypingRef = React__namespace.useRef(false);
    // eslint-disable-next-line react-hooks/exhaustive-deps
    var syncCodeToState = React__namespace.useCallback(debounce__default["default"](function (code) {
        var onStatusChange = onStatusChangeRef.current;
        if (isSynchingFromExternal.current) {
            return;
        }
        isSynchingFromCodeMirror.current = true;
        try {
            var newAST_1 = parser.Parser.parseProgram(code);
            reka.change(function () {
                diffAST(currentStateRef.current, newAST_1);
                diffAST(reka.program, currentStateRef.current);
            });
            onStatusChange === null || onStatusChange === void 0 ? void 0 : onStatusChange({
                type: 'success',
            });
        }
        catch (error) {
            onStatusChange === null || onStatusChange === void 0 ? void 0 : onStatusChange({
                type: 'error',
                error: error.message,
            });
        }
        isSynchingFromCodeMirror.current = false;
        isTypingRef.current = false;
    }, 1000), [reka]);
    var _c = __read(React__namespace.useState(null), 2), codemirrorView = _c[0], setCodemirrorView = _c[1];
    React__namespace.useEffect(function () {
        var dom = domRef.current;
        if (!dom) {
            return;
        }
        var onStatusChange = onStatusChangeRef.current;
        setCodemirrorView(new view.EditorView({
            state: state.EditorState.create({
                doc: currentCodeStringRef.current,
                extensions: __spreadArray([
                    codemirror.basicSetup,
                    view.keymap.of([commands.indentWithTab]),
                    codemirror$1.reka(),
                    view.EditorView.theme({
                        '&': {
                            height: '100%',
                        },
                        '&.cm-focused': {
                            outline: 'none!important',
                        },
                        '.cm-scroller': {
                            'font-family': "'JetBrains Mono'",
                            fontSize: '0.875em',
                            lineHeight: '1.6em',
                            wordBreak: 'break-word',
                            '-webkit-font-smoothing': 'initial',
                        },
                        '.cm-gutters': {
                            backgroundColor: '#fff',
                            color: 'rgba(0,0,0,0.4)',
                        },
                    }),
                    view.EditorView.updateListener.of(function (view) {
                        if (!view.docChanged || isSynchingFromExternal.current) {
                            return;
                        }
                        isTypingRef.current = true;
                        currentCodeStringRef.current = view.state.doc.toString();
                        onStatusChange === null || onStatusChange === void 0 ? void 0 : onStatusChange({
                            type: 'parsing',
                        });
                        syncCodeToState(currentCodeStringRef.current);
                    })
                ], __read(extensionsRef.current), false),
            }),
            parent: dom,
        }));
    }, [syncCodeToState]);
    var onExternalChange = React__namespace.useCallback(function () {
        if (isSynchingFromCodeMirror.current || isTypingRef.current) {
            return;
        }
        if (!codemirrorView) {
            return;
        }
        if (isSynchingFromExternal.current === false) {
            isSynchingFromExternal.current = true;
            Promise.resolve().then(function () {
                var oldCode = currentCodeStringRef.current;
                var newCode = parser.Parser.stringify(reka.program);
                if (newCode === oldCode) {
                    isSynchingFromExternal.current = false;
                    return;
                }
                currentStateRef.current = t__namespace.Schema.fromJSON(reka.program);
                var transaction = codemirrorView.state.update({
                    changes: {
                        from: 0,
                        to: codemirrorView.state.doc.length,
                        insert: newCode,
                    },
                });
                currentCodeStringRef.current = newCode;
                codemirrorView.dispatch(transaction);
                isSynchingFromExternal.current = false;
            });
        }
    }, [reka, codemirrorView]);
    console.log('TTTTTT');
    // If the AST changes (ie: from undo/redo or from multiplayer),
    // Then, sync those changes to the CodeMirror editor
    React__namespace.useEffect(function () {
        var unsubscribe = reka.listenToChanges(function (payload) {
            if (payload.event !== 'change') {
                return;
            }
            onExternalChange();
        });
        return function () {
            unsubscribe();
        };
    }, [reka, codemirrorView, onExternalChange]);
    return React__namespace.createElement("div", __assign({}, props, { ref: domRef }));
};
CodeEditor.toString = function () { return '.reka-react-code-editor'; };

exports.CodeEditor = CodeEditor;
